<?php
/**
 * SEF URLs that use a file-like layout and include topic name and forum name
 * where applicable.
 *
 * @copyright (C) 2008-2011 PunBB, partially based on code (C) 2008-2009 FluxBB.org
 * @license http://www.gnu.org/licenses/gpl.html GPL version 2 or higher
 * @package PunBB
 */


// Make sure no one attempts to run this script "directly"
if (!defined('FORUM'))
	exit;

// These are the "fancy" file based SEF URLs
$forum_url = array(
	'insertion_find'				=>  '.html',
	'insertion_replace'				=>  '-$1.html',
	'change_email'					=>	'change-email$1.html',
	'change_email_key'				=>	'change-email$1-$2.html',
	'change_password'				=>	'change-password$1.html',
	'change_password_key'			=>	'change-password$1-$2.html',
	'delete_user'					=>	'delete-user$1.html',
	'delete'						=>	'delete$1.html',
	'delete_avatar'					=>	'delete-avatar$1-$2.html',
	'edit'							=>	'edit$1.html',
	'email'							=>	'email$1.html',
	'forum'							=>	'forum$1-$2.html',
	'forum_rss'						=>	'feed-rss-forum$1.xml',
	'forum_atom'					=>	'feed-atom-forum$1.xml',
	'forum_subscribe'				=>	'subscribe-forum$1-$2.html',
	'forum_unsubscribe'				=>	'unsubscribe-forum$1-$2.html',
	'help'							=>	'help-$1.html',
	'index'							=>	'',
	'index_rss'						=>	'feed-rss.xml',
	'index_atom'					=>	'feed-atom.xml',
	'login'							=>	'login.html',
	'logout'						=>	'logout$1-$2.html',
	'mark_read'						=>	'mark-read-$1.html',
	'mark_forum_read'				=>	'mark-forum$1-read-$2.html',
	'new_topic'						=>	'new-topic$1.html',
	'new_reply'						=>	'new-reply$1.html',
	'post'							=>	'post$1.html#p$1',
	'profile_about'					=>	'user$1-about.html',
	'profile_identity'				=>	'user$1-identity.html',
	'profile_settings'				=>	'user$1-settings.html',
	'profile_avatar'				=>	'user$1-avatar.html',
	'profile_signature'				=>	'user$1-signature.html',
	'profile_admin'					=>	'user$1-admin.html',
	'quote'							=>	'new-reply$1quote$2.html',
	'register'						=>	'register.html',
	'report'						=>	'report$1.html',
	'request_password'				=>	'request-password.html',
	'rules'							=>	'rules.html',
	'search'						=>	'search.html',
	'search_advanced'				=>	'search-advanced.html',
	'search_resultft'				=>	'search-k$1-$4-a$3-$5-$6-$2-$7.html',
	'search_results'				=>	'search$1.html',
	'search_new'					=>	'search-new.html',
	'search_new_results'			=>	'search-new-$1.html',
	'search_recent'					=>	'search-recent.html',
	'search_recent_results'			=>	'search-recent-$1.html',
	'search_unanswered'				=>	'search-unanswered.html',
	'search_subscriptions'			=>	'search-subscriptions$1.html',
	'search_forum_subscriptions'	=>	'search-forum-subscriptions$1.html',
	'search_user_posts'				=>	'search-posts-user$1.html',
	'search_user_topics'			=>	'search-topics-user$1.html',
	'subscribe'						=>	'subscribe$1-$2.html',
	'topic'							=>	'topic$1-$2.html',
	'topic_rss'						=>	'feed-rss-topic$1.xml',
	'topic_atom'					=>	'feed-atom-topic$1.xml',
	'topic_new_posts'				=>	'topic$1-$2-new-posts.html',
	'topic_last_post'				=>	'topic$1last-post.html',
	'unsubscribe'					=>	'unsubscribe$1-$2.html',
	'user'							=>	'user$1.html',
	'users'							=>	'users.html',
	'users_browse'					=>	'users/$4/$1$2-$3.html',
	'page'							=>	'p$1',
	'moderate_forum'				=>	'moderate$1.html',
	'get_host'						=>	'get_host$1.html',
	'move'							=>	'move_topics$1-$2.html',
	'open'							=>	'open$1-$2-$3.html',
	'close'							=>	'close$1-$2-$3.html',
	'stick'							=>	'stick$1-$2-$3.html',
	'unstick'						=>	'unstick$1-$2-$3.html',
	'moderate_topic'				=>	'moderate$1-$2.html',
	'admin_index'					=>	'admin/index.php',
	'admin_bans'					=>	'admin/bans.php?sort_by=1',
	'admin_categories'				=>	'admin/categories.php',
	'admin_censoring'				=>	'admin/censoring.php',
	'admin_extensions_manage'		=>	'admin/extensions.php?section=manage',
	'admin_extensions_hotfixes'		=>	'admin/extensions.php?section=hotfixes',
	'admin_forums'					=>	'admin/forums.php',
	'admin_forums_forum'			=>	'admin/forums.php#forum$1',
	'admin_groups'					=>	'admin/groups.php',
	'admin_loader'					=>	'admin/loader.php',
	'admin_reindex'					=>	'admin/reindex.php',
	'admin_settings_setup'			=>	'admin/settings.php?section=setup',
	'admin_settings_features'		=>	'admin/settings.php?section=features',
	'admin_settings_content'		=>	'admin/settings.php?section=content',
	'admin_settings_email'			=>	'admin/settings.php?section=email',
	'admin_settings_announcements'	=>	'admin/settings.php?section=announcements',
	'admin_settings_registration'	=>	'admin/settings.php?section=registration',
	'admin_settings_communications'	=>	'admin/settings.php?section=communications',
	'admin_settings_maintenance'	=>	'admin/settings.php?section=maintenance',
	'admin_prune'					=>	'admin/prune.php',
	'admin_ranks'					=>	'admin/ranks.php',
	'admin_reports'					=>	'admin/reports.php',
	'admin_users'					=>	'admin/users.php'
);
